﻿@using LoyaltyPointEngine.Model.Object.AutomateCampaign

@{
    string search = ViewBag.Search,
        orderColumn = ViewBag.OrderColumn,
        orderDirection = ViewBag.OrderDirection;

    int currentPage = ViewBag.CurrentPage,
        totalPage = ViewBag.TotalPage,
        paginationShowRange = 5,
        totalRow = ViewBag.TotalData,
        campaignID = ViewBag.CampaignID;

    bool isSPG = ViewBag.IsSpg != null ? (bool)ViewBag.IsSpg : false;
}
@model List<ParticipantModel>
<div id="tblParticipantContainer" class="widget-content">
    <div class="right-title">
        <form name="gridForm">
            <input type="text" id="txtSearch" name="txtSearch" value="@search" class="form-control box-search" placeholder="Search for...">
            <input type="hidden" id="rawDataUrl" name="rawDataUrl" value="@GenerateUrl(campaignID,"@search@", orderColumn, orderColumn, orderDirection, 0)" />
        </form>
    </div>
    <div id="grid-wrapper" class="widget-content">
        <table class="table table-striped grid-table">
            <thead>
                <tr>
                    <th class="grid-header" title="MemberName"><div class="grid-header-title"><a data-url="@GenerateUrl(campaignID,search, "MemberName", orderColumn, orderDirection, 0)">Name</a></div></th>
                    <th class="grid-header" title="Email"><div class="grid-header-title"><a data-url="@GenerateUrl(campaignID,search, "Email", orderColumn, orderDirection, 0)">Email</a></div></th>
                    <th class="grid-header" title="Phone"><div class="grid-header-title"><a data-url="@GenerateUrl(campaignID,search, "Phone", orderColumn, orderDirection, 0)">Phone</a></div></th>
                    <th class="grid-header" title="Point"><div class="grid-header-title"><a data-url="@GenerateUrl(campaignID,search, "Point", orderColumn, orderDirection, 0)">Point</a></div></th>
                    <th class="grid-header cell-center" title=""><div class="grid-header-title"><span></span></div></th>
                </tr>
            </thead>
            <tbody>
                @foreach (ParticipantModel member in Model)
                {
                    <tr class="grid-row ">
                        <td class="grid-cell" data-name="MemberName">@member.MemberName</td>
                        <td class="grid-cell" data-name="Email">@member.Email</td>
                        <td class="grid-cell" data-name="Phone">@member.Phone</td>
                        <td class="grid-cell" data-name="Point">@member.Point</td>
                        @if (!isSPG)
                        {
                            <td class="grid-cell cell-center" data-name=""><a onclick="confirmDelete('Are you sure want to remove @member.Email from member?', '@(Url.Action(MVC.MemberParticipantACB.Delete(member.MemberID)))')" class="btn btn-xs btn-danger">Delete</a></td>
                        }
                    </tr>
                }
            </tbody>
        </table>
        @if (totalPage > 1)
        {
            int startPage = currentPage - paginationShowRange > 1 ? currentPage - paginationShowRange : 1,
                endPage = currentPage + paginationShowRange < totalPage ? currentPage + paginationShowRange : totalPage;

            <div class="grid-footer">
                <div class="grid-pager">
                    <ul class="pagination">
                        <li>
                            <a data-url="@GenerateUrl(campaignID,search, orderColumn, orderColumn, orderDirection, currentPage <= 1 ? currentPage : currentPage - 1, true)" class="grid-prev-page" title="Previous Page" style="">
                                <span class="glyphicon glyphicon-step-backward"></span>
                            </a>
                        </li>
                        @for (var _page = startPage; _page <= endPage; _page++)
                        {
                            @*<li><a href="#" class="grid-pageSetLink prev" style="display: none;" data-pageset="1" data-partitionsize="5">...</a></li>*@
                            <li class="@(currentPage == _page ? "active": "")">
                                <a data-url="@GenerateUrl(campaignID,search, orderColumn, orderColumn, orderDirection, _page, true)" class="grid-page-link">
                                    @_page
                                </a>
                            </li>
                        }
                        @*<li>
                                <a class="grid-page-link">
                                    of @totalPage
                                </a>
                            </li>*@
                        <li>
                            <a data-url="@GenerateUrl(campaignID,search, orderColumn, orderColumn, orderDirection, currentPage >= endPage ? endPage : currentPage + 1, true)" title="Next Page" class="grid-next-page">
                                <span class="glyphicon glyphicon-step-forward"></span>
                            </a>
                        </li>
                    </ul>
                </div>
                <div>Total Row: @totalRow </div>
            </div>
        }
    </div>
    </div>
    @functions {
        public string GetOrderDirectionByColumn(string currentCol, string currentDirection, string targetColumn, bool isPaging)
        {
            if (isPaging) return currentDirection;

            if (currentCol.ToLower() == targetColumn.ToLower())
            {
                if (currentDirection.ToLower() == "asc") return "desc";
                else return "asc";
            }
            return currentDirection;
        }

        public string GenerateUrl(int campaignID, string search, string targetColumn, string orderColumn, string orderDirection, int? page, bool isPaging = false)
        {
            return Url.Action(MVC.MemberParticipantACB.GridGetAllPager(campaignID, search, targetColumn, GetOrderDirectionByColumn(orderColumn, orderDirection, targetColumn, isPaging), page));
        }
    }

